//---------------------------------------------------------------------------------------------------------------------------
//	二次配布okです。Dayonn_dayonnに連絡不要です。
//	一般公開okです。公開の際、事前にDayonn_dayonnへの連絡をお願いします。
//	改変okです。事前連絡不要です。事後連絡不要です。
//---------------------------------------------------------------------------------------------------------------------------
//	2018/08/20	v1.0.0	Dayonn_dayonn	気まぐれで新規作成。検証用に使う予定。たぶん公開しない。
//	2018/10/23	v1.0.1	Dayonn_dayonn	色変更、表示位置変更、常時表示からしゃがみ時表示へ変更。
//	2018/10/23	v1.0.2	Dayonn_dayonn	しゃがみながら移動したり攻撃しても表示されるように変更。
//	2019/05/25	v1.0.2	Dayonn_dayonn	体力の減少に合わせ表示色が変わるように変更。
//	2019/09/23	v1.0.4	Dayonn_dayonn	公開を前提としたソースコード見直し。機能自体に変更は無し。
//	2019/09/24	v1.0.5	Dayonn_dayonn	表示のちらつき防止のため、表示時間を 0.55 -> 0.65 に変更。
//	2020/07/31	v1.1.0	Dayonn_dayonn	機能を大幅に追加。かなり変わりすぎて、コード行数が10倍近いw
//										・体力表示の色変化をNMRiH本体と全く一緒になるよう、CVARからの読み取り and 色変化のスムーズ化。
//										・状態異常・チャージ攻撃力・攻撃時のダメージ表示を追加。
//										・Gray83様 [NMRiH] Health & Armor Vampirism との同時利用を想定し、1行目を非表示にできるよう機能追加。
//											(https://forums.alliedmods.net/showthread.php?t=300674)
//										・表示位置変更機能を追加。
//	2020/08/02	v1.1.1	Dayonn_dayonn	2行表示を3行表示に変更。翻訳機能を追加。チャージ投げでもチャージ攻撃量を表示していたので非表示に修正。
//	2020/08/07	v1.1.2	Dayonn_dayonn	色の変化の計算式が間違えていたので修正。
//	2020/08/26	v1.1.3	Dayonn_dayonn	それぞれの文字位置をcfgで設定できるよう変更。(cfgを変更することで、2行表示ができる。)
//										Lord Stranker 様の要望により、キーバインド設定できるよう機能追加。
//
//	未定			もし次にバージョンアップするなら...
//											・チャージ攻撃力をcfgからではなく読み取るようにする。
//---------------------------------------------------------------------------------------------------------------------------


#pragma semicolon 1
#pragma newdecls required

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#define PLUGIN_VERSION "1.1.3"



public Plugin myinfo = {
	name = "health_and_stamina_disp",
	author = "Dayonn_dayonn",
	description = "Display health, stamina, debuff, charge value and damage value",
	version = PLUGIN_VERSION
};

const int iDamage_Count_Max = 5;						// ダメージの最大表示数。
const float fCharge_Show_Time = 4.5;					// チャージ量表示をリセットする秒数。
const float fDamage_Show_Time = 4.5;					// ダメージ表示をリセットする秒数。
const float fPrint_Time = 0.15;							// 1回ごとに表示する時間。表示がちらつく場合は、この数字を大きくする。
const float fPrint_Repeat_time = 0.1;					// 表示する処理を何秒ごとに繰り返すか。


KeyValues hConfig;										// Status_Display.cfg へのハンドル。
int iIs_Print_Health_Cfg;								// 体力とスタミナ表示をするかどうか(cfgによる設定)。keyvalueから拾う関係上、boolではなくint。
float fHealth_Print_x = 0.02;							// 体力を表示する位置 x
float fHealth_Print_y = 0.86;							// 体力を表示する位置 y
float fCharge_Print_x = 0.02;							// チャージ量を表示する位置 x
float fCharge_Print_y = 0.90;							// チャージ量を表示する位置 y
float fDamage_Print_x = 0.02;							// ダメージを表示する位置 x
float fDamage_Print_y = 0.94;							// ダメージを表示する位置 y
char sBind_Cmd[64] = "";								// bindのコンソールコマンド。
char sAlias_Cmd1[70];									// aliasのコンソールコマンド。
char sAlias_Cmd2[70];									// aliasのコンソールコマンド。

bool bIs_Print_Health_Swich[MAXPLAYERS + 1];			// 体力とスタミナ表示をするかどうか(フラグ)。

float fMAX_Charge;										// CVAR "sv_max_charge_length"  default: 3.5
float fCharge_Per_Sec;									// CVAR "sv_melee_dmg_per_sec"  default: 0.571
float fMaglite_Factor;									// CVAR "sv_maglite_melee_factor"  default: 0.35
float fEtool_pick_Factor;								// CVAR "sv_etool_pick_damage_modifier"  default: 1.5
int iZombie_Health;										// CVAR "sv_zombie_health"
int iRunner_Health;										// = CVAR "sv_runner_health_fraction" * "sv_zombie_health"
int iKid_Health;										// = CVAR "sv_kid_health_fraction" * "sv_zombie_health"

int iWeapon[MAXPLAYERS + 1];							// 装備中武器のエンティティのID
char sWeapon[MAXPLAYERS + 1][32];						// 装備中武器の名前
int iShortest_Charging_Damage[MAXPLAYERS + 1];			// 武器変更時、.cfgファイルから読み込む。.cfgファイルの値は.ctxファイルの"HeadshotDamage"と同じ値にする。
														// 本来ならば.ctxファイルから読み込んだ方がいいけれど、呼び出し方法が分からない..。
int iCharge_Attack[MAXPLAYERS + 1];						// 画面に表示するチャージ攻撃のチャージ量。チャージ量を表示するかどうかのフラグにも使用。
bool bIs_Freeze;										// ゲーム自体がフリーズ状態(脱出時のカメラ演出の間・ラウンド開始時の1秒以下の動けない時間)かどうか
bool bIs_Charge_Attack[MAXPLAYERS + 1];					// チャージ攻撃をしているかどうかを格納する。
int iDamage_Count[MAXPLAYERS + 1];						// 一定時間内に何回ダメージを与えたか。ダメージ表示をするかどうかのフラグにも使用。
int iDamage[MAXPLAYERS + 1][iDamage_Count_Max + 1];		// 与えたダメージ量の配列
char sDamage_Print[MAXPLAYERS + 1][20 + 7 * iDamage_Count_Max + 2 + 5]; 	// 与えたダメージを画面表示できるよう処理した文字列。翻訳対応のため大目にとってある。
																			// ダメージ量4桁として、 [必要文字数 + 安全を見て5文字]
Handle hDamage_Print_Timer[MAXPLAYERS + 1];				// ダメージ表示タイマーのハンドル。
Handle hCharge_Print_Timer[MAXPLAYERS + 1];				// チャージ量表示タイマーのハンドル。



public void OnPluginStart()
{
	LoadTranslations("health_and_stamina_disp.phrases");
	Load_Config();
	Load_CVAR();
	Hook_Change_CVAR();
	Hook_Events();
	CreateTimer(fPrint_Repeat_time, Repeat_Print, _, TIMER_REPEAT);
}



public void Load_Config()
{
	hConfig = new KeyValues("health_and_stamina_disp.cfg");
	char sConfig_Path[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sConfig_Path, sizeof(sConfig_Path), "configs/health_and_stamina_disp.cfg");
	if (!hConfig.ImportFromFile(sConfig_Path)) {
		SetFailState("[health_and_stamina_disp]: Couldn't load 'health_and_stamina_disp.cfg' from ...addons/sourcemod/configs/");
	}

	// Display Config のロード
	hConfig.JumpToKey("Display_Config",false);
	iIs_Print_Health_Cfg = hConfig.GetNum("Noting_Health_and_stamina", 0);
	fHealth_Print_x = hConfig.GetFloat("Health_Display_Position_x", 0.020);
	fHealth_Print_y = hConfig.GetFloat("Health_Display_Position_y", 0.860);
	fCharge_Print_x = hConfig.GetFloat("Charge_Display_Position_x", 0.020);
	fCharge_Print_y = hConfig.GetFloat("Charge_Display_Position_y", 0.900);
	fDamage_Print_x = hConfig.GetFloat("Damage_Display_Position_x", 0.020);
	fDamage_Print_y = hConfig.GetFloat("Damage_Display_Position_y", 0.940);

	char sBind_Key[16] = "";
	hConfig.GetString("Key_Bind", sBind_Key, sizeof(sBind_Key), "");
	if (!StrEqual(sBind_Key, ""))
	{
		RegConsoleCmd("sm_health_and_stamina_swich", Health_Disp_Swich,"",1);
		FormatEx(sAlias_Cmd1, sizeof(sAlias_Cmd1), "alias +sm_health_and_stamina_disp sm_health_and_stamina_swich 1");
		FormatEx(sAlias_Cmd2, sizeof(sAlias_Cmd2), "alias -sm_health_and_stamina_disp sm_health_and_stamina_swich 0");
		FormatEx(sBind_Cmd, sizeof(sBind_Cmd), "bind %s +sm_health_and_stamina_disp", sBind_Key);
	}
	hConfig.GoBack();
	hConfig.JumpToKey("Headshot_Damage_with_Shortest_Charging",false);		//頻繁に使用するから、先にジャンプしておく。
}



public void Load_CVAR()
{
	fMAX_Charge = FindConVar("sv_max_charge_length").FloatValue;
	fCharge_Per_Sec = FindConVar("sv_melee_dmg_per_sec").FloatValue;
	fMaglite_Factor = FindConVar("sv_maglite_melee_factor").FloatValue;
	fEtool_pick_Factor = FindConVar("sv_etool_pick_damage_modifier").FloatValue;
	iZombie_Health = FindConVar("sv_zombie_health").IntValue;
	iRunner_Health = RoundToZero(float(iZombie_Health) * FindConVar("sv_runner_health_fraction").FloatValue);
	iKid_Health = RoundToZero(float(iZombie_Health) * FindConVar("sv_kid_health_fraction").FloatValue);
}



public void Hook_Change_CVAR()
{
	FindConVar("sv_max_charge_length").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_melee_dmg_per_sec").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_maglite_melee_factor").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_etool_pick_damage_modifier").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_zombie_health").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_runner_health_fraction").AddChangeHook(OnCVAR_Change);
	FindConVar("sv_kid_health_fraction").AddChangeHook(OnCVAR_Change);
}



public void OnCVAR_Change(ConVar hCVAR, char[] sOld_Value, char[] sNew_Value)
{
	char sCVAR_Name[64];
	hCVAR.GetName(sCVAR_Name, sizeof(sCVAR_Name));

	if (StrEqual(sCVAR_Name, "sv_max_charge_length"))
	{
		fMAX_Charge = StringToFloat(sNew_Value);
	}
	else if (StrEqual(sCVAR_Name, "sv_melee_dmg_per_sec"))
	{
		fCharge_Per_Sec = StringToFloat(sNew_Value);
	}
	else if (StrEqual(sCVAR_Name, "sv_maglite_melee_factor"))
	{
		fMaglite_Factor = StringToFloat(sNew_Value);
	}
	else if (StrEqual(sCVAR_Name, "sv_etool_pick_damage_modifier"))
	{
		fEtool_pick_Factor = StringToFloat(sNew_Value);
	}
	else if (StrEqual(sCVAR_Name, "sv_zombie_health"))
	{
		iZombie_Health = StringToInt(sNew_Value);
		iRunner_Health = RoundToZero(float(iZombie_Health) * FindConVar("sv_runner_health_fraction").FloatValue);
		iKid_Health = RoundToZero(float(iZombie_Health) * FindConVar("sv_kid_health_fraction").FloatValue);
	}
	else if (StrEqual(sCVAR_Name, "sv_runner_health_fraction"))
	{
		iRunner_Health = RoundToZero(float(iZombie_Health) * StringToFloat(sNew_Value));
	}
	else if (StrEqual(sCVAR_Name, "sv_kid_health_fraction"))
	{
		iKid_Health = RoundToZero(float(iZombie_Health) * StringToFloat(sNew_Value));
	}
}



public void Hook_Events()
{
	HookEvent("player_spawn", OnPlayer_spawn_Post, EventHookMode_Post);
	HookEvent("nmrih_reset_map", OnReset_Map_Pre, EventHookMode_Pre);
	HookEvent("nmrih_round_begin", OnRound_Begin_Post, EventHookMode_Post);
	HookEvent("freeze_all_the_things", OnFreeze_Post, EventHookMode_Post);
}



// プレイヤーのスポーン直後、初期化をする。
public void OnPlayer_spawn_Post(Event hEvent, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(hEvent.GetInt("userid"));

	// チャージ量リセット、フラグとフラグのタイマーもリセット
	iCharge_Attack[client] = 0;
	bIs_Charge_Attack[client] = false;
	if (hCharge_Print_Timer[client] != INVALID_HANDLE)
	{
		KillTimer(hCharge_Print_Timer[client]);
		hCharge_Print_Timer[client] = INVALID_HANDLE;
	}

	// ダメージリセット、タイマーもリセット
	iDamage_Count[client] = 0;
	if (hDamage_Print_Timer[client] != INVALID_HANDLE)
	{
		KillTimer(hDamage_Print_Timer[client]);
		hDamage_Print_Timer[client] = INVALID_HANDLE;
	}
}



// マップ開始 and リスタートの瞬間で、ラウンドがリセットされる直前(ただし、練習時間のスタートは除く)、
// プレイヤーが操作できないことを変数に取得する。
public void OnReset_Map_Pre(Event hEvent, const char[] name, bool dontBroadcast)
{
	bIs_Freeze = true;
}



// マップ開始 or リスタート にて、動けるようになった直後、プレイヤーが操作できることを変数に取得する。
public void OnRound_Begin_Post(Event hEvent, const char[] name, bool dontBroadcast)
{
	bIs_Freeze = false;
}



// 脱出時のカメラ演出へ切り替わった後と戻った後、プレイヤーが操作できるかどうかを変数で取得する。
public void OnFreeze_Post(Event hEvent, const char[] name, bool dontBroadcast)
{
 	bIs_Freeze = hEvent.GetBool("frozen");
	if(bIs_Freeze)
	{
		// チャージ表示の初期化。ダメージ表示の初期化はしない。
		for (int client = 1; client <= MaxClients; client++)
		{
			// チャージ量リセット、フラグとフラグのタイマーもリセット
			iCharge_Attack[client] = 0;
			bIs_Charge_Attack[client] = false;
			if (hCharge_Print_Timer[client] != INVALID_HANDLE)
			{
				KillTimer(hCharge_Print_Timer[client]);
				hCharge_Print_Timer[client] = INVALID_HANDLE;
			}
		}
	}
}



// クライアントログイン後に、キーバインド・武器変更フックを追加。
public void OnClientPostAdminCheck(int client)
{
	if(IsFakeClient(client)) return;
	if (!StrEqual(sBind_Cmd, ""))
	{
		ClientCommand(client, sAlias_Cmd1);
		ClientCommand(client, sAlias_Cmd2);
		ClientCommand(client, sBind_Cmd);
	}
	SDKHook(client, SDKHook_WeaponSwitchPost, On_Weapon_Switch_Post);
}



// 	クライアント切断前に、武器変更フックを解除。
public void OnClientDisconnect(int client)
{
	if(IsFakeClient(client)) return;
	SDKUnhook(client, SDKHook_WeaponSwitchPost, On_Weapon_Switch_Post);
}



// キーを押したときに、体力表示フラグをtrueにする。
public Action Health_Disp_Swich(int client_RegConsoleCmd, int args)
{
	// Listen Server での RegConsoleCmd 対策。強引に0を1にする。
	int client;
	if (client_RegConsoleCmd == 0)
	{
		client = 1;
	}
	else client = client_RegConsoleCmd;

	char sArg[2];	//引数。"0"か"1"のどちらか。
	GetCmdArg(1, sArg, sizeof(sArg));
	if (StrEqual(sArg, "1"))
	{
		bIs_Print_Health_Swich[client] = true;
	}else{
		bIs_Print_Health_Swich[client] = false;
	}
	return Plugin_Handled;
}



// 武器変更後に、武器ID・武器名・ヘッドショットダメージを取得。
public Action On_Weapon_Switch_Post(int client, int iTemp)
{
	iWeapon[client] = iTemp;
	if (IsValidEntity(iWeapon[client]))
	{
		if (HasEntProp(iWeapon[client], Prop_Send, "m_bIsCharging"))
		{
			GetEntityClassname(iWeapon[client], sWeapon[client], sizeof(sWeapon[]));
			iShortest_Charging_Damage[client] = hConfig.GetNum(sWeapon[client], -10);
				//検証のため、初期値を -10 にしている。.cfgファイルのリストに武器名が見つからない場合は、チャージ量がマイナス表示される。
		}
	}
	return Plugin_Continue;
}



// 画面表示を行う。画面表示の更新時間・描画時間は定数で調整する。
public Action Repeat_Print(Handle hTimer)
{
	if (MaxClients == 0)return Plugin_Continue;		// クライアントが参加できない状態(マップ変更中等)なら、終了。
	if (bIs_Freeze)return Plugin_Continue;
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			if (!IsClientTimingOut(client) && IsPlayerAlive(client))
			{
				// 体力表示フラグがtrueの時に体力とスタミナを取得・表示する。
				if(iIs_Print_Health_Cfg == 0)
				{
					if (StrEqual(sBind_Cmd, ""))	//キーバインドされていないときは、しゃがんでいるかどうかで判定する。
					{
						if (GetEntProp(client, Prop_Send, "m_bDucked") == 1) bIs_Print_Health_Swich[client] = true;
					}
					
					if(bIs_Print_Health_Swich[client])		
					{
						// 体力・スタミナの文字列を生成
						int iHealth = GetClientHealth(client);
						int iStamina = RoundToZero(GetEntPropFloat(client, Prop_Send, "m_flStamina", 0));
						char sHealth_Text[128];
						FormatEx(sHealth_Text, sizeof(sHealth_Text), "%T", "Health", client, iHealth, iStamina);

						// 出血・感染・ワクチン接種の文字列を生成
						if(GetEntProp(client, Prop_Send, "_bleedingOut") == 1)
						{
							Format(sHealth_Text, sizeof(sHealth_Text), "%T", "bleeding", client, sHealth_Text);		//文字列の再編集なので、安全のためFormatを使う。
						}

						if(GetEntProp(client, Prop_Send, "_vaccinated") == 1)
						{
							Format(sHealth_Text, sizeof(sHealth_Text), "%T", "vaccinated", client, sHealth_Text);
						}
						else 
						{
							float fInfection_Death_Time = GetEntPropFloat(client, Prop_Send, "m_flInfectionDeathTime");
							if(fInfection_Death_Time != -1.0)
							{
								Format(sHealth_Text, sizeof(sHealth_Text), "%T", "infected", client, sHealth_Text, RoundToCeil(fInfection_Death_Time - GetGameTime()));
							}
						}				

						// 体力・スタミナの文字列を表示
						int iText_Color_r, iText_Color_g, iText_Color_b;
						iText_Color_b = 0;
						if (iHealth > 99)		// 100
						{
							iText_Color_r = 0;
							iText_Color_g = 255;
						}
						else if (iHealth > 66)		// 99 - 67
						{
							iText_Color_r = RoundToNearest(((100.0 - float(iHealth)) / 34.0) * 255.0);
							iText_Color_g = 255;
						}
						else if (iHealth > 33)		// 66 - 34
						{
							iText_Color_r = 255;
							iText_Color_g = RoundToNearest((float(iHealth) - 33.0) / 33.0 * 255.0);
						}
						else		// 33 - 0
						{
							iText_Color_r = 255;
							iText_Color_g = 0;
						}
						SetHudTextParams(fHealth_Print_x, fHealth_Print_y, fPrint_Time, iText_Color_r, iText_Color_g, iText_Color_b, 255, 0, 0.0, 0.0, 0.0);
						ShowHudText(client, -1, sHealth_Text);
					}
				}

				// チャージ攻撃時のチャージ量を取得する。
				if (HasEntProp(iWeapon[client], Prop_Send, "m_bIsCharging"))
				{
					if (GetEntProp(iWeapon[client], Prop_Send, "m_bIsCharging") == 1)
					{
						if (GetEntPropFloat(client, Prop_Send, "m_flThrowDropTimer") == -1.0)	// 投げチャージならGameTimeが入る。攻撃チャージなら-1.0
						{

							// チャージ攻撃のチャージ量を計算
							float fCharge_Time = GetGameTime() - GetEntPropFloat(iWeapon[client], Prop_Send, "m_flLastBeginCharge");
							Calculate_Charge_Attack(client, fCharge_Time);

							// フラグOn、タイマーをリセット
							bIs_Charge_Attack[client] = true;
							if (hCharge_Print_Timer[client] != INVALID_HANDLE)
							{
								KillTimer(hCharge_Print_Timer[client]);
								hCharge_Print_Timer[client] = INVALID_HANDLE;
							}
						}
					}
					else
					{
						// チャージ攻撃を放った直後だった場合、最終チャージ量を取得する。
						if(bIs_Charge_Attack[client])
						{
							// チャージ攻撃の最終チャージ量を計算
							float fCharge_Time = GetEntPropFloat(iWeapon[client], Prop_Send, "m_flLastChargeLength");
							Calculate_Charge_Attack(client, fCharge_Time);

							// フラグOff、タイマーをセット
							bIs_Charge_Attack[client] = false;
							hCharge_Print_Timer[client] = CreateTimer(fCharge_Show_Time, Reset_Charge, GetClientUserId(client));
						}
					}
				}

				// チャージ量の文字列を生成・表示する。
				if(iCharge_Attack[client] > 0)
				{
					char sCharge_Text[32];		//翻訳対応のため文字数を大目にとってある。

					// チャージ量の文字列を生成
					FormatEx(sCharge_Text, sizeof(sCharge_Text), "%T", "Charge", client, iCharge_Attack[client]);

					// チャージ量の文字列を表示
					int iText_Color_r, iText_Color_g, iText_Color_b;
					iText_Color_b = 0;
					if (iCharge_Attack[client] < iKid_Health)		// だれも一撃で倒せない .. 緑
					{
						iText_Color_r = 0;
						iText_Color_g = 255;
					}
					else if (iCharge_Attack[client] < iRunner_Health)		// kid以下を一撃で倒せる .. 黄色
					{
						iText_Color_r = 255;
						iText_Color_g = 255;
					}
					else if (iCharge_Attack[client] < iZombie_Health)		// runner以下を一撃で倒せる .. オレンジ
					{
						iText_Color_r = 255;
						iText_Color_g = 127;
					}
					else		// 通常ゾンビを一撃で倒せる .. 赤
					{
						iText_Color_r = 255;
						iText_Color_g = 0;
					}
					SetHudTextParams(fCharge_Print_x, fCharge_Print_y, fPrint_Time, iText_Color_r, iText_Color_g, iText_Color_b, 255, 0, 0.0, 0.0, 0.0);
					ShowHudText(client, -1, sCharge_Text);
				}

				// ダメージ量の文字列を表示する。
				if(iDamage_Count[client] > 0)
				{
					// ダメージ量の文字列を表示
					SetHudTextParams(fDamage_Print_x, fDamage_Print_y, fPrint_Time, 0, 255, 0, 255, 0, 0.0, 0.0, 0.0);
					ShowHudText(client, -1, sDamage_Print[client]);
				}
			}
		}
	}
	return Plugin_Continue;
}



// チャージ攻撃のチャージ量を計算する。
public void Calculate_Charge_Attack(int client, float fCharge_Time)
{
	if (fCharge_Time < 0.0)
	{
		fCharge_Time = 0.0;		// 構え動作中はマイナスになるから0に直す。
	}
	else if (fCharge_Time > fMAX_Charge)
	{
		fCharge_Time = fMAX_Charge;
	}

	// 計算
	float fAttack = float(iShortest_Charging_Damage[client]) * (1.0 + fCharge_Per_Sec * fCharge_Time);
	if (StrEqual(sWeapon[client], "item_maglite"))
	{
		fAttack = fAttack * fMaglite_Factor;
	} 
	else if (StrEqual(sWeapon[client], "me_etool"))
	{
		if (GetEntProp(iWeapon[client], Prop_Send, "_pickActive") == 1)
		{
			fAttack = fAttack * fEtool_pick_Factor;
		}
	}
	iCharge_Attack[client] = RoundToZero(fAttack);
}



// チャージ攻撃を放ってから一定時間後にチャージ量をリセットする。クライアントの切断・接続により変数clientが再利用される可能性があるため、UseIDを引数にする。
public Action Reset_Charge(Handle timer, int iUser_Id)
{
	int client = GetClientOfUserId(iUser_Id);
	iCharge_Attack[client] = 0;
	hCharge_Print_Timer[client] = INVALID_HANDLE;

	return Plugin_Continue;
}



// 新しいエンティティが出来た時、やみくもにフックをつける。
// SDKHook_OnTakeDamagePost プロパティのないエンティティだった場合は返り値にfalseが出力されるが、返り値は必要ない。
public void OnEntityCreated(int entity, const char[] classname)
{
	SDKHookEx(entity, SDKHook_OnTakeDamagePost, OnTake_Damage_Post);
		// エンティティが削除されるかプラグインがアンロードされれば、自動的にUnHookされる。
		// なので、KeyValueでHookしたエンティティのリストを保持しておいて、あとでSDKUnhookで丁寧に消していくといったようなことはしなくていい。
}



// 何かがダメージを受けた時、プレイヤーからの攻撃かを確認し、ダメージ表示の文字列を生成する。
public void OnTake_Damage_Post(int victim, int iAttacker, int inflictor, float fDamage, int damagetype)
{
	if(1 <= iAttacker && iAttacker <= MaxClients)
	{
		if(victim != iAttacker)		// 自殺・出血・炎上ダメージ等、攻撃者が自分であるダメージは表示しない。
		{
			FormatEx(sDamage_Print[iAttacker], sizeof(sDamage_Print[]), "%T", "Damage", iAttacker);
			if(iDamage_Count[iAttacker] == iDamage_Count_Max)
			{
				// 表示位置をずらして、文字列化
				for (int i = 1; i <= iDamage_Count_Max - 1; i++)
				{
					iDamage[iAttacker][i] = iDamage[iAttacker][i + 1];
				}
				iDamage[iAttacker][iDamage_Count_Max] = RoundToNearest(fDamage);

				// 表示用文字列生成
				Format(sDamage_Print[iAttacker], sizeof(sDamage_Print[]), "%s...", sDamage_Print[iAttacker], iDamage[iAttacker][1]);
				for (int i = 1; i <= iDamage_Count[iAttacker]; i++)
				{			
					Format(sDamage_Print[iAttacker], sizeof(sDamage_Print[]), "%s + %i", sDamage_Print[iAttacker], iDamage[iAttacker][i]);
						// 同じ変数の再編集なので、FormatExは使わない。
				}
			}
			else
			{
				// 文字列化
				iDamage_Count[iAttacker] = iDamage_Count[iAttacker] + 1;
				iDamage[iAttacker][iDamage_Count[iAttacker]] = RoundToNearest(fDamage);

				// 表示用文字列生成
				Format(sDamage_Print[iAttacker], sizeof(sDamage_Print[]), "%s%i", sDamage_Print[iAttacker], iDamage[iAttacker][1]);
				if(iDamage_Count[iAttacker] >= 2)
				{
					for (int i = 2; i <= iDamage_Count[iAttacker]; i++)
					{			
						Format(sDamage_Print[iAttacker], sizeof(sDamage_Print[]), "%s + %i", sDamage_Print[iAttacker], iDamage[iAttacker][i]);
							// 同じ変数の再編集なので、FormatExは使わない。
					}
				}
			}

			// ダメージ表示タイマーをリセット、再セット。
			if (hDamage_Print_Timer[iAttacker] != INVALID_HANDLE)
			{
				KillTimer(hDamage_Print_Timer[iAttacker]);
				hDamage_Print_Timer[iAttacker] = INVALID_HANDLE;
			}
			hDamage_Print_Timer[iAttacker] = CreateTimer(fDamage_Show_Time, Reset_Damage, GetClientUserId(iAttacker));
		}
	}
}



// 最後にダメージを与えてから一定時間後にダメージ表示をリセットする。クライアントの切断・接続により変数clientが再利用される可能性があるため、UseIDを引数にする。
public Action Reset_Damage(Handle timer, int iUser_Id)
{
	int client = GetClientOfUserId(iUser_Id);
	iDamage_Count[client] = 0;
	hDamage_Print_Timer[client] = INVALID_HANDLE;
	return Plugin_Continue;
}




//以下は開発時のメモ。

// ダメージ受けた時、文字が上にぽよーんと飛び出る演出? FFみたいな感じに。出来たら面白い。が、文字のエンティティを追加、表示する方法が分からない...

/* "weapon_fired"は、発射する関係の武器しかフックできない。近接攻撃はフックできない...

public void OnPluginStart()
{
	HookEvent("weapon_fired", OnWeapon_Fired_Post, EventHookMode_Post);
}

public void OnWeapon_Fired_Post(Event hEvent, const char[] name, bool dontBroadcast)
{
	int player_id = hEvent.GetInt("player_id");
	int client = GetClientOfUserId(hEvent.GetInt("player_id"));

	PrintToChatAll("player_id = %i, client = %i  attack", player_id, client);
}
*/


/* HookEntityOutput でフックしても、ダメージを取得できるわけじゃない。攻撃を受けたことは分かるが、ダメージ量は分からない。

public void OnPluginStart()
{
	HookEntityOutput("prop_physics", "OnTakeDamage", On_Damage_Post_physics);
	HookEntityOutput("prop_dynamic", "OnTakeDamage", On_Damage_Post_dynamic);
	HookEntityOutput("func_breakable", "OnTakeDamage", On_Damage_Post_dynamic);
}

// 木箱
public void On_Damage_Post_physics(const char[] output, int caller, int activator, float delay)
{
	PrintToChatAll("physics. '%s', 被害者= %i, 攻撃者= %i, delay= %f", output, caller, activator, delay);
}

// 動く金網の扉・femaバッグ・プラケース
public void On_Damage_Post_dynamic(const char[] output, int caller, int activator, float delay)
{
	PrintToChatAll("dynamic. '%s', 被害者= %i, 攻撃者= %i, delay= %f", output, caller, activator, delay);
}

public void On_Damage_Post_breakable(const char[] output, int caller, int activator, float delay)
{
	PrintToChatAll("breakable. '%s', 被害者= %i, 攻撃者= %i, delay= %f", output, caller, activator, delay);
}
*/


/*ダメージの文字列生成の時、ImplodeStringsは使わない。文字列全体をくっつけてしまうので、攻撃回数が最大回数に満たない場合、余計な文字列がくっついてしまう。
int ImplodeStrings(const char[][] strings, int numStrings, const char[] join, char[] buffer, int maxLength)

ほかにも、表示用文字列を再編集して表示用文字列を作成する方法とかを考えたが、文字列操作が複雑になりそうだったので、ダメージを個別に配列で格納することにした。
*/


/* マウスをクリックして指を離した直後の動作をチャージ攻撃かどうかを判定し、タイマーをセットする。
にしてみたけど、指を離してから実際にチャージが終了し攻撃に移行するまでに1～2フレームほどのタイムラグがあるようで、この時点でチャージ終了の扱いをすると
実際に発生したダメージとずれがでてくるのでダメだった。

public void Hook_Events()
{
	RegConsoleCmd("-attack", OnAttack_Pre );
}

public Action OnAttack_Pre(int client_RegConsoleCmd, int args)
{
	// Listen Server での RegConsoleCmd 対策。強引に0を1にしちゃう。
	int client;
	if (client_RegConsoleCmd == 0)
	{
		client = 1;
	}
	else client = client_RegConsoleCmd;

	if (!bIs_Freeze && IsPlayerAlive(client) && bIs_Charge_Attack[client])
	{
		bIs_Charge_Attack[client] = false;
		
		// タイマーセット
		hCharge_Print_Timer[client] = CreateTimer(fCharge_Show_Time, Reset_Charge, GetClientUserId(client));
	}
	return Plugin_Continue;
}
*/
